#include "blc_array_tcp4_server.h"
#include <cstdarg>

START_EXTERN_C
blc_array_tcp4_server *blc_array_tcp4_server_new_void(char const *port_name){
    return new blc_array_tcp4_server(port_name);
}

blc_array_tcp4_server *blc_array_tcp4_server_new(char const*port_name, uint32_t type, uint32_t format, int dims_nb, size_t length0, ...){
    va_list arguments;
    vector<size_t> lengths(dims_nb, length0);
    
    va_start(arguments, length0);
    for (int i=1; i<dims_nb; i++) lengths[i] = va_arg(arguments, size_t);
    va_end(arguments);
    return new blc_array_tcp4_server(port_name, type, format, lengths);;
}

void blc_array_tcp4_server_recv_data(blc_array_tcp4_server *server){
    server->recv_data();
}

void blc_array_tcp4_server_send_data(blc_array_tcp4_server *server){
    server->send_data();
}

int blc_array_tcp4_server_wait_connection(blc_array_tcp4_server *server){
    return server->wait_connection();
}
void blc_array_tcp4_server_delete(blc_array_tcp4_server *server){
    delete server;
}
END_EXTERN_C

/*
blc_array_tcp4_server_thread::blc_array_tcp4_server_thread(blc_array *array, string const &port_name):blc_array_tcp4_server(array, port_name){
    server_thread=make_unique<thread>([this](){
        while(1) read_data();
    });
}
*/



